
#ifndef WIN32

#define FAR

typedef unsigned char BYTE, *LPBYTE;
typedef unsigned short WORD, *LPWORD;
typedef unsigned long DWORD, *LPDWORD;
typedef long LONG;

typedef bool BOOL;
#define TRUE true
#define FALSE false

#pragma pack(push, 2)
#pragma pack(2)

typedef struct tagBITMAPFILEHEADER {
        WORD    bfType;
        DWORD   bfSize;
        WORD    bfReserved1;
        WORD    bfReserved2;
        DWORD   bfOffBits;
} BITMAPFILEHEADER, FAR *LPBITMAPFILEHEADER, *PBITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
        DWORD      biSize;
        LONG       biWidth;
        LONG       biHeight;
        WORD       biPlanes;
        WORD       biBitCount;
        DWORD      biCompression;
        DWORD      biSizeImage;
        LONG       biXPelsPerMeter;
        LONG       biYPelsPerMeter;
        DWORD      biClrUsed;
        DWORD      biClrImportant;
} BITMAPINFOHEADER, FAR *LPBITMAPINFOHEADER, *PBITMAPINFOHEADER;

#pragma pack()
#pragma pack(pop)

#define BI_RGB        0L

#ifndef WIN32
inline void ZeroMemory(void *p, size_t size) {
  memset(p, 0, size);
}
template<typename T> T min(T x, T y) {
  return((x < y) ? x : y);
}
#endif

#endif
